

# Personalizing AI for co-creative music composition 

This simple but new co-creative music composition approach
was used for creating the instrumental song [The Last Moment Before You Fly](algomus.fr/before-you-fly/),
in a collaboration between the [Algomus](http://www.algomus.fr) team
and the composer and sound designer [Sébastien Gulluni](http://sebastiengulluni.com/).
The song was ranked 3rd in the [AI Song Contest 2021](https://en.wikipedia.org/wiki/AI_Song_Contest_2021).


We *personalize* the artificial creativity methods to adapt to the needs and expectations of a composer.
Interactions between the composer and different AI methods occurred throughout the whole composition process, for the generation of melodies, chord progressions, global structure, and textural variations,
both through *data sharing* for machine learning based AI 
and through *knowledge sharing* for rule-based AI.

This code is using python 3.5.

## Chord generation

The chord generation is done with a non-probabilistic factor oracle using `chordgen.py`. The command takes as argument the folder containing the chord progressions in text form, and then an optional argument of which file should be the starting point of the oracle.

```python3 chordgen.py [chords_folder] ([start_file])```

Example (on dummy chords data):

```
python3 factor-oracle/chordgen.py data/chords/ data/chords/ch2.txt
```

## Melody generation on chord progression

The melody generation is done with a probabilistic factor oracle using `melodygen.py`. The probabilistic models are conveniently already pre-trained on dummy data. The command takes two arguments: first the folder containing the melody (with chord information) in musicXML format, and second the scenario, i.e. the chord progression (in musicXML format) on which the melody will be generated.

```python3 melodygen.py [melody_folder] [scenario]```

Example (on dummy melody data):
```
python3 factor-oracle/melodygen.py data/melody data/melody/Ornithology.xml
```

## Structure and variation generation

The *structure* are generated by a hand-cradted first-order Markov model
with additional constraints on the number of sections and chords. 

A simple taxonomy of *variations* on rhythm, melody, and timbre/texture
was formalized with the composer.
A generative procedure based on a random selection of variations, upon generative curves, generates where and how
variations are to be applied.
The curves define how many variations are being randomly selected out of the taxonomy of variations for each section of the piece.

Transitions, constraints, and curves were *humanly crafted*, in particular  following conversations between the computer music team and the composer.

Example:
```
python3 structure/structures-variations.py 
```


## License

The code is licensed under the GNU General Public License v3.0 or any later version.

## References

*(factor oracle)*
K. Déguernel, E. Vincent, G. Assayag. [Probabilistic factor oracles for multidimensional machine improvisation.](https://hal.inria.fr/hal-01693750) *Computer Music Journal*, 42:2, 2018.

*(structure and variations)*
K. Déguernel, M. Giraud, R. Groult, S. Gullunin,
[Personalizing AI for co-creative music composition from melody to structure](https://hal.archives-ouvertes.fr/hal-03618015),
*SMC 2022* (accepted paper, upcoming), 2022.
